-- test bench : le banc de test lui mme
-- tbench.vhd

library ieee ;
use ieee.std_logic_1164.all,ieee.numeric_std.all ;
use work.tbenchpg.all ;

entity tbench is
   generic (retard : time := 0 ns ;
            tck : time := 20 ns ;
            tailleresult : positive := 2 ;
            test : vectable := ("00","01","10","11") 
            ) ;
   constant taillevect : positive := test'high(2) ;
   constant sequence : positive := test'high(1) ;
end tbench ;

architecture struct of tbench is
   signal vectcom : std_logic_vector(1 to taillevect) ;
   signal testdata : vectable(1 to sequence,1 to taillevect) := test ;
   signal resultat : std_logic_vector(tailleresult-1 downto 0) ;
   signal hor : std_ulogic ;
   signal stop : boolean := false ;
   signal roule : boolean ;
begin
   dut : cobaye
      port map ( hor => hor,
                 commande => vectcom,
                 sorties => resultat ) ;
   horloge : genhor  port map (tck => tck,
                               hor => hor) ;

   gene : genvect
      generic map (retard => retard,
                   taillevect => taillevect,
                   sequence => sequence)
      port map ( hor => hor,
                 stop => stop,
                 start => roule,
                 testin => testdata,
                 vectout => vectcom,
                 finseq => roule) ;
end struct ;
