-- detection de trois zeros, 3 bascules, sortie anticipee
-- tz_meal3.vhd

library ieee ;
use ieee.std_logic_1164.all ;

entity trois_zero is
	port ( hor, din : in std_logic ;
          tzero : out std_logic ) ;
end trois_zero ;

architecture mealy3 of trois_zero is
constant aucun     : std_logic_vector(2 downto 0) := "000" ;
constant unzero    : std_logic_vector(2 downto 0) := "001" ;
constant deuxzero  : std_logic_vector(2 downto 0) := "010" ;
constant troiszero : std_logic_vector(2 downto 0) := "100" ;
signal etat, futur : std_logic_vector(2 downto 0) ;
begin
tzero <= futur(2) ;
evolution : process
begin
	wait until rising_edge(hor) ;
		etat <= futur ;
end process evolution ;

transitions : process(din, etat)
begin
	if din = '1' then
		futur <= aucun ;
	else
		case etat is
			when aucun 	=> futur <= unzero ;
			when unzero 	=> futur <= deuxzero ;
			when deuxzero 	=> futur <= troiszero ;
			when troiszero 	=> futur <= unzero ;
			when others	=> futur <= aucun ;
		end case ;
	end if ;
end process transitions ;
end mealy3 ;


